<?php

namespace FiloBlu\Refilo\Model\Exporter;

use FiloBlu\Refilo\Model\Adapter\Mongo;
use Magento\Framework\App\Config\ScopeConfigInterface;
use Magento\Framework\App\ResourceConnection;
use stdClass;

class Translations
{
    /**
     * @var ResourceConnection
     */
    private $resourceConnection;
    /**
     * @var Mongo
     */
    private $mongo;
    /**
     * @var ScopeConfigInterface
     */
    private $scopeConfig;

    /**
     * Menu constructor.
     * @param ResourceConnection $resourceConnection
     * @param ScopeConfigInterface $scopeConfig
     * @param Mongo $mongo
     */
    public function __construct(
        ResourceConnection $resourceConnection,
        ScopeConfigInterface $scopeConfig,
        Mongo $mongo
    ) {
        $this->resourceConnection = $resourceConnection;
        $this->scopeConfig = $scopeConfig;
        $this->mongo = $mongo;
    }

    public function exportTranslations()
    {
        $this->mongo->dropCollection("translations", $this->scopeConfig->getValue('mongo/general/mongo_general_database'));
        $bulkData = [];
        $_id = 1;
        $query = "SELECT * FROM `translation`";

        $result = $this->resourceConnection->getConnection()->fetchAll($query);

        foreach ($result as $item) {
            $translation = new stdClass();

            $translation->_id = $_id;
            $translation->string = $item['string'];
            $translation->translation = $item['translate'];
            $translation->locale_code = $item['locale'];
            $bulkData[] = $translation;
            $_id++;
        }

        try {
            $this->mongo->update(
                '_id',
                $bulkData,
                'translations',
                true,
                $this->scopeConfig->getValue('mongo/general/mongo_general_database')
            );

        } catch (MongoDB\Driver\Exception\Exception $e) {
            echo $e->getMessage();
        }
    }
}
