<?php

namespace FiloBlu\Refilo\Model\Indexer\Processor\Type;

use Magento\Catalog\Model\Product;
use stdClass;

abstract class AbstractType
{

    /**
     * @var array
     */
    protected $_swatch_options;

    /**
     * @var array
     */
    protected $_options;

    /**
     * @var Product
     */
    protected $_product;
    /**
     * @var stdClass
     */
    protected $_item;

    /**
     * @var array
     */
    protected $_product_attributes;

    protected $allowedInputTypes = [
        'boolean',
        'multiselect',
        'select',
    ];

    /**
     * @return array
     */
    public function getProductAttributes()
    {
        return $this->_product_attributes;
    }

    /**
     * @param array $product_attributes
     */
    public function setProductAttributes($product_attributes)
    {
        $this->_product_attributes = $product_attributes;
    }

    /**
     * @return mixed
     */
    public function getProduct()
    {
        return $this->_product_collection;
    }

    /**
     * @param mixed $product_collection
     */
    public function setProduct($product)
    {
        $this->_product = $product;
    }

    /**
     * @return stdClass
     */
    public function getItem()
    {
        return $this->_item;
    }

    /**
     * @return array
     */
    public function getSwatchOptions()
    {
        return $this->_swatch_options;
    }

    /**
     * @param array $swatch_options
     */
    public function setSwatchOptions($swatch_options)
    {
        $this->_swatch_options = $swatch_options;
    }

    /**
     * @return array
     */
    public function getOptions(): array
    {
        return $this->_options;
    }

    /**
     * @param array $options
     */
    public function setOptions(array $options): void
    {
        $this->_options = $options;
    }

    abstract protected function process();

    abstract protected function processBasedata();

    abstract protected function processAssets();

    abstract protected function processAttributes();

    abstract protected function processFilters();

    abstract protected function processSortables();

    abstract protected function processCategories();

    abstract protected function processPrices();

    abstract protected function processInventory();
}
